﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Runtime.InteropServices;
using System.Globalization;
using System.Xml.Linq;
using System.Xml;

namespace NEW_MAP
{
    public partial  class Form1 : Form
    {
       
         public void CreateObjectFunc()
         {
             //выбираем тип объекта из классификатора
             if (!MapSelectObjectRsc1.ExecuteForMapObj(MapObj1.C_CONTAINER, true)) return;
             MapEditMetric1.MetEditMode = axGisToolKit.TxEditMode.emCreate;
             //если был выбран объект-подпись
             if (MapObj1.Local == axGisToolKit.TxObjectLocal.OL_TEXT)
             {
                 EditText EditTextForm = new EditText();
                 DialogResult dialogResult = EditTextForm.ShowDialog();
                 //выбрали кнопку "ОК", и поле текста не пустое  
                 if ((dialogResult == DialogResult.OK) && (EditTextForm.textBox1.Text.Length > 0))
                 {
                     //устанавливаем текст подписи
                    MapObj1.Text_set(0, EditTextForm.textBox1.Text);
                 }
             }
             MapEditMetric1.StartAction();
         }

         public void CreateObjectFromFileFunc()
         {
             //отображаем диалоговое окно для открытия файла
             OpenFileDialog dlg = new OpenFileDialog();
             //фильтр файлов
             dlg.Filter = "Файлы XML (*.xml)|*.xml";
             if (dlg.ShowDialog() != DialogResult.OK)
                 return;

             //получаем массив значений тегов и их атрибутов
             el = get_tag_value(dlg.FileName.ToString());
             for (int g = 0; g <= el.Count - 1; g++)
             {
                 //разбиваем строку с координатами на отдельные значения
                 String[] coortags = el[g][4].Split(new char[] { ' ' },
                     StringSplitOptions.RemoveEmptyEntries);
                 //заменяем словесное представление типа локализации на числовое 
                 switch (el[g][1])
                 {
                     case "точечный": el[g][1] = "00000002";
                         break;
                     case "площадной": el[g][1] = "00000001";
                         break;
                     case "линейный": el[g][1] = "00000000";
                         break;
                     case "подпись": el[g][1] = "00000003";
                         break;
                     case "векторный": el[g][1] = "00000004";
                         break;
                 }

                 //создаем пустой объект определенного типа

                 MapObj1.CreateObjectByExcode(MapView1.MapHandle,
                                             (int)axGisToolKit.TxMetricType.IDFLOAT2,
                                             Convert.ToInt32(el[g][2]),
                                             Convert.ToInt32(el[g][1]));
                 //если объект-подпись, добавляем текст подписи в объект
                 if (el[g][3].ToString() != " ")
                     MapObj1.Text_set(0, el[g][3].ToString());
                 //устанавливаем координаты в м
                 MapPoint1.PlaceInp = axGisToolKit.TxPPLACE.PP_PLANE;
                 try
                 {
                     for (int h = 1; h <= coortags.Count() - 1; h++)
                     {
                         if ((h - 1) % 2 == 0)
                         {
                             //добавляем в метрику объекта координаты X и Y
                             mypoint.X = Convert.ToDouble(coortags[h - 1]);
                             mypoint.Y = Convert.ToDouble(coortags[h]);
                             MapPoint1.SetPoint(mypoint.X, mypoint.Y);
                             MapObj1.Metric.Append(0, MapPoint1.C_CONTAINER);
                         }
                     }
                 }
                 catch (Exception ex)
                 {
                     MessageBox.Show("Неверный формат XML файла!");
                     break;
                 }
                 //записываем и перерисовываем объект
                 MapObj1.Commit();
                 MapObj1.Repaint();

             }
             MapView1.Repaint();
         }
    }
}
