﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.IO;


namespace NEW_MAP
{
    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
    public struct TASKPARMEX  // Параметры вызова диалогов 
    {
        public int Language; // Код языка диалогов (1 - ENGLISH, 
        // 2 - RUSSIAN, ...) 
        public int Resource;// Должен быть 0! 
        public IntPtr HelpName;// Полное имя файла ".hlp" 
        public IntPtr IniName;// Полное имя файла ".ini" приложения 
        public IntPtr PathShell;// Каталог приложения (exe,dll,...) 
        public IntPtr ApplicationName;// Имя приложения 
        public int Handle;// Идентификатор главного окна приложения 
        public int DocHandle;

        public void Init()
        {
            Language = 1;
            Resource = 0;
            HelpName = IntPtr.Zero;
            IniName = IntPtr.Zero;
            PathShell = IntPtr.Zero;
            ApplicationName = IntPtr.Zero;
            Handle = 0;
            DocHandle = 0;
        }
    }
    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
    public struct ARRAYNAME
    {
      public int Code; // Код семантики для поиска
      public int Title; // Признак учета подписей
      public int Count;//Количество установленных названий семантик
      [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4096)]
      public char[,] semname;
      public void Init()
        {
            Code = 0;
            Title = 0;
            Count = 0;
            semname = new char[16, 256];
        }
    }
 
  
    public struct COLOR
    {
     public axGisToolKit.TxColorRef aColor;
     public void Init()
     {//задаем цвет выделения объектов в виде RGB
          aColor = new axGisToolKit.TxColorRef();
          aColor.Red = 243;
          aColor.Green = 0;
          aColor.Blue = 97;
        }
    }
    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
    public struct DOUBLEPOINT                     // КООРДИНАТЫ ТОЧКИ
    {
        public double X;
        public double Y;
        public void Point(double x, double y)
        {
            X = x; Y = y;
        }
    }

    public class Semantic_DLG
    {
     public const string GisLibrary1 = "C:\\Windows\\SysWOW64\\gisforms.dll";
     [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
     public static extern int selSearchName(int hmap,
                                            int select, 
                                            ref ARRAYNAME arname,
                                            ref TASKPARMEX parm);
    }
    public class PASPAPI
    {
        
        public const string GisLibrary3 = "C:\\Windows\\SysWOW64\\gisdlgs.dll";


        //public const string GisLibrary2 = "C:\\Windows\\SysWOW64\\gispasp.dll";
        [DllImport(GisLibrary2, CharSet = CharSet.Ansi)]
        public static extern int paspCreateMap(int hmap, 
                                               StringBuilder mapname, 
                                               int size, 
                                               ref TASKPARMEX parm);

        public const string GisLibrary2 = "C:\\Windows\\SysWOW64\\gispasp.dll";
        [DllImport(GisLibrary2, CharSet = CharSet.Ansi)]
        public static extern int paspCreatePlan(StringBuilder mapname, 
                                                int size, 
                                                ref TASKPARMEX parm);

    }
    public class EditMapObj
    {
        public const string GisLibrary1 = "C:\\Windows\\SysWOW64\\gisacces.dll";   
        //удалить подобъект по номеру
        [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
        public static extern int mapDeleteSubject(int info,int number);
        
        // удалить объект по порядковому номеру
        [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
        public static extern int mapDeleteObjectByNumber(int hMap, 
                                                         int list, int number);
        // получить порядковый номер объекта
        [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
        public static extern int mapGetObjectNumber(int info);
        

        //перемещение объекта на величину delta
         [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
         public static extern int mapRelocateObject(int hmap, int info, ref DOUBLEPOINT delta, int place);

         //создать копию объекта 
         [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
         public static extern int mapCreateCopyObject(int hMap, int info);
       
        //рассечение объекта по линии
        [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
        public static extern int mapCreateObjectCutByLine(int info1, int info2, int method, double precision);

        //рассечение объекта по линии
        [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
        public static extern int mapGetNextCut(int hCross, int info);
       
        //получение результирующих объектов после рассечения 
        [DllImport(GisLibrary1, CharSet = CharSet.Ansi)]
        public static extern int mapFreeObjectsCut(int hCross);
    }
 
}
